module BST (Tree, empty, isEmpty, insert, member) where

import Test.QuickCheck
import Control.Monad

data Tree a = Node (Tree a) a (Tree a) | Empty
            deriving (Show, Eq)

-- Simple generator for trees
instance (Ord a, Arbitrary a) => Arbitrary (Tree a) where
  arbitrary = foldr insert empty `fmap` arbitrary

empty :: Tree a
empty = Empty

isEmpty :: Tree a -> Bool
isEmpty Empty = True
isEmpty _     = False

insert :: Ord a => a -> Tree a -> Tree a
insert x Empty = Node Empty x Empty
insert x (Node lt y rt)
  | x >  y    = Node (insert x lt) y rt
  | otherwise = Node lt y (insert x rt)

memberC :: Ord a => a -> Maybe a -> Tree a -> Bool
memberC x Nothing  Empty          = False
memberC x (Just c) Empty          = x == c
memberC x c (Node lt y rt)
  | x < y = memberC x c lt
  | otherwise = memberC x (Just y) lt

member :: Ord a => a -> Tree a -> Bool
member x = memberC x Nothing

-- Write the properties required in the assignment description
